<?php
/*
Plugin Name: bsuite
Plugin URI: http://maisonbisson.com/blog/search/bsuite
Description: It's okay for a few things, but you could probably do better
Version: 0.0.b2 Nov 28
Author: Casey Bisson
Author URI: http://maisonbisson.com/blog/
*/

/*  Copyright 2005  Casey Bisson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//
// bsuite sometimes gets called outside the WP context. This include makes it work
//
if(!$wpdb){
	require_once("../../wp-config.php");
	$bsuite_standalone = 1;
	}

//
// identify the bsuite tables
//
global $bsuite_tables;
$bsuite_tables[bstat_hits] = $table_prefix . "bstat_hits";
$bsuite_tables[bstat_refs] = $table_prefix . "bstat_refs";
$bsuite_tables[bsuite_speedcache] = $table_prefix . "bsuite_speedcache";
$bsuite_tables[bsuggestive_index] = "bsuggestive";
//$bsuite_tables[bstat_out] = $table_prefix . "bstat_out";



//
// fetch objects from the cache
//
function bsuite_speedcache_fetch($obj, $minutes = 5, $return = FALSE, $lib = 'user') {
//	return(FALSE);

	global $wpdb;

	$date  = date("Y-m-d H:i:s", mktime( date("H"), date("i") - $minutes, date("s"), date("m"), date("d"), date("Y")));
	$obj = addslashes($obj);
	$lib = addslashes($lib);

	$request = "SELECT * FROM wp_bsuite_speedcache
		WHERE cache_item = '$obj'
		AND cache_bank = '$lib'
		AND cache_date >= '$date'
		LIMIT 1
		;";

//	print_r($request);

	$rows = $wpdb->get_results($request);

//	print_r($rows);

	if(count($rows)){
		$cachedata = '<!-- start bsuite_speedcache object ' . $rows[0] -> cache_bank . '/'. $rows[0] -> cache_item . ' on ' . $rows[0] -> cache_date . '-->' . $rows[0] -> cache_content . '<!-- end bsuite_speedcache object -->';
		if($return){
			return($cachedata);
		}else{
			echo $cachedata;
			return(TRUE);
			}
	}else{
		return(FALSE);
		}
	}
// end function bsuite_speedcache_fetch



//
// put objects into the cache
//
function bsuite_speedcache_put($obj, $content, $echo = TRUE, $lib = 'user') {
	global $wpdb;

	if($echo)
		echo '<!-- start bsuite_speedcache object ' . $lib . '/'. $obj . ' refreshed -->' . $content . '<!-- end bsuite_speedcache object -->';

	$date = date("Y-m-d H:i:s");
	$obj = addslashes($obj);
	$lib = addslashes($lib);
	$content = addslashes($content);

	$request = "REPLACE INTO wp_bsuite_speedcache 
		(cache_date, cache_bank, cache_item, cache_content) VALUES ('$date', '$lib', '$obj', '$content');";

//	print_r($request);

	$wpdb->query($request);
	}
// end function bsuite_speedcache_put



//
// Referrer tracking
//
function bstat_getref() {

	$raw_referrer = $_SERVER["HTTP_REFERER"];

	// these fix problems with google.ca's query identifyer
	$raw_referrer = ereg_replace("as_q=", "q=", $raw_referrer);
	$raw_referrer = ereg_replace("as_qdr=", "q=", $raw_referrer);

	// this fixes some sites that don't have a query identifyer
	$raw_referrer = str_replace("a9.com/", "a9.com/?q=", $raw_referrer);
	$raw_referrer = str_replace("technorati.com/tag/", "technorati.com/?q=", $raw_referrer);
	$raw_referrer = str_replace("technorati.com/tags/", "technorati.com/?q=", $raw_referrer);
	$raw_referrer = str_replace("technorati.com/search/", "technorati.com/?q=", $raw_referrer);

	$raw_referrer = split("\?", $raw_referrer);
	$referrer = $raw_referrer[0];
	$raw_searchstring = split("&", $raw_referrer[1]);

	$querystringidentifyer = NULL;
	switch (true) {
		case (ereg("google", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("yahoo", $referrer)):
			$querystringidentifyer = "p=";
			break;
		case (ereg("altavista", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("a9", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("aolsearch", $referrer)):
			$querystringidentifyer = "query=";
			break;
		case (ereg("search.msn", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("dashbar", $referrer)):
			$querystringidentifyer = "k=";
			break;
		case (ereg("mywebsearch", $referrer)):
			$querystringidentifyer = "searchfor=";
			break;
		case (ereg("mysearch", $referrer)):
			$querystringidentifyer = "searchfor=";
			break;
		case (ereg("baidu", $referrer)):
			$querystringidentifyer = "word=";
			break;
		case (ereg("technorati.com", $referrer)):
			$querystringidentifyer = "q=";
			break;
		case (ereg("zoek.metaseek.nl", $referrer)):
			$querystringidentifyer = "qry=";
			break;
		case (ereg("answers.com", $referrer)):
			$querystringidentifyer = "s=";
			break;
		case (ereg("tiscali.co.uk", $referrer)):
			$querystringidentifyer = "query=";
			break;
		case (ereg("comcast.net", $referrer)):
			$querystringidentifyer = "query=";
			break;
		default:
			$querystringidentifyer = "q=";
			//echo "$referrer $raw_referrer[1]\n";
			break;
		}
	
	$searchstring = NULL;
	foreach($raw_searchstring as $test_searchstring){
		if(ereg(("^" . $querystringidentifyer), $test_searchstring)){
			$searchstring = urldecode(ereg_replace($querystringidentifyer, "", $test_searchstring));
			}
		}
	if(!$searchstring){
		$issearchengine = 0;
		$searchstring = $_SERVER["HTTP_REFERER"];
	}else{
		$issearchengine = 1;
		}

	// this fixes things that get buggy for google cache referrers
	if(ereg("cache", $searchstring))
		$issearchengine = 0;

	$result = NULL;
	$result['issearchengine'] = $issearchengine;
	$result['searchstring'] = $searchstring;

	$_REQUEST['hilite_words'] = urlencode($searchstring);
	
	return($result);
	}
// end function bstat_getref



//
// ignore hits from certain IPs (configure in options tab)
// returns true if the client IP matches one in get_settings('bstat_ignoreips')
// this feature requested by Zach, blame him for any problems....
//
function bstat_ignorethisip() {
	//echo "<h1>Looking for IPs to ignore...</h1>";
	$bstat_ignoreips = ereg_replace("\.", "\\.", get_settings('bstat_ignoreips')); 
	$bstat_ignoreips = ereg_replace("\*", "(.*)", $bstat_ignoreips);
	$bstat_ignoreips = explode("\n", $bstat_ignoreips);
	foreach($bstat_ignoreips as $ignoreip){
		//$ignoreip = substr($ignoreip, 0, -1);
		if($ignoreip){
			//echo "<h1>$ignoreip</h1>";
			if(ereg("^" . $ignoreip . "$", $_SERVER[REMOTE_ADDR])){
				//echo "<h1>IP Match</h1>";
				return(true);
				}
			}
		}
	return(false);
	}
// end function bstat_ignorethisip



//
// increment the hit counters for story reads and ad hits
//
function bstat_hitit($post_id, $what) {
	static $bstat_shortcircuit = FALSE;
	
	if($bstat_shortcircuit)
		return(TRUE);

	global $wpdb, $bsuite_tables;

	if(!((get_settings('bstat_ignoreips')) && (bstat_ignorethisip()))){
		$hits_reads = 0;
		$hits_ads1 = 0;
		$hits_ads2 = 0;
		
		$date = date("Y-m-d");
	
		$request = "SELECT * FROM $bsuite_tables[bstat_hits] 
			WHERE post_id = $post_id
			AND bstat_date = '$date'
			LIMIT 1
			";
	
		$rows = $wpdb->get_results($request);
	
		if(count($rows)==0){
			switch($what){
				case "read":
					$hits_reads = 1;
					break;				
				case "ads1":
					$hits_ads1 = 1;
					break;				
				case "ads2":
					$hits_ads2 = 1;
					break;
				default:
					$hits_reads = 1;
					break;				
				}
				
			$request = "INSERT INTO $bsuite_tables[bstat_hits] 
				(bstat_date, post_id, hits_reads, hits_ads1, hits_ads2) VALUES ('$date', $post_id, $hits_reads, $hits_ads1, $hits_ads2);";
	
		}else{
			$request = "UPDATE $bsuite_tables[bstat_hits] ";
			
			foreach($rows as $row){
				switch($what){
					case "read":
						$request .= "SET hits_reads = " . ($row->hits_reads + 1) . " ";
						break;				
					case "ads1":
						$request .= "SET hits_ads1 = " . ($row->hits_ads1 + 1) . " ";
						break;				
					case "ads2":
						$request .= "SET hits_ads2 = " . ($row->hits_ads2 + 1) . " ";
						break;
					default:
						$request .= "SET hits_reads = " . ($row->hits_reads + 1) . " ";
						break;				
					}
				}
				$request .= "WHERE bstat_id = " . $row->bstat_id;
			}
	
		$wpdb->query($request);
		}
	

	//
	// now track the referer tags
	//
	$referer = bstat_getref();


	//
	// filter out blacklisted refs
	//
	$blacklist = get_option('bstat_refmoderation');
	if($blacklist == 1){
		$blacklist = get_option('moderation_keys');
		$blacklist .= "\n";
		$blacklist .= get_option('blacklist_keys');
		$blacklist = explode("\n", $blacklist);

		foreach($blacklist as $killword){
			$killword = substr($killword, 0, -1);
			//echo "<h1>$killword, $referer[searchstring]</h1>";
			if($killword){
				if(eregi($killword, $referer[searchstring])){
					// now putting these in their own category. 
					// issearchengine isn't a simple binary anymore
					$referer[issearchengine] = 3;
					}
				}
			}
		}

	//
	// this puts self-references in their own category
	// needs to be expanded so it can self-detect the base URL properly
	//
	//if(eregi("maisonbisson.com/blog", $referer[searchstring])){
	if(eregi(str_replace("www.", "", $_SERVER["HTTP_HOST"]), $referer[searchstring])){
		//echo "<h1>Hit!</h1>";
		$referer[issearchengine] = 4;
		}

	if($referer[searchstring]){
		$request = "SELECT * FROM $bsuite_tables[bstat_refs] 
			WHERE post_id = $post_id
			AND bstat_date = '$date'
			AND ref = '" . urlencode($referer[searchstring]) . "'
			LIMIT 1
			";
	
		$rows = $wpdb->get_results($request);
	
		if(count($rows)==0){
			$request = "INSERT INTO $bsuite_tables[bstat_refs] 
				(bstat_date, post_id, hits, issearchengine, ref) VALUES ('$date', $post_id, 1, '$referer[issearchengine]', '" . urlencode($referer[searchstring]) . "');";
	
		}else{
			$request = "UPDATE $bsuite_tables[bstat_refs] ";
			
			foreach($rows as $row){
				$request .= "SET hits = " . ($row->hits + 1) . " ";
				}
			$request .= "WHERE bstat_id = " . $row->bstat_id;
			}
	
		$wpdb->query($request);

		//echo "<h1>$request</h1>";
		//print_r($referer);


		//
		// put the words of the referrer into a table individually
		//
		if($referer[issearchengine] == 1){
			$words = eregi_replace("[^a-z|A-Z|0-9| ]", " ", $referer[searchstring]);
			$words = explode(" ", $words);
			//print_r($words);
			
			foreach($words as $word){
				if($word){
					$request = "SELECT * FROM $bsuite_tables[bstat_words] 
						WHERE bstat_date = '$date'
						AND word = '$word'
						LIMIT 1
						";
				
					//echo "<h1>$request</h1>";
					$rows = $wpdb->get_results($request);
				
					if(count($rows)==0){
						$request = "INSERT INTO $bsuite_tables[bstat_words] 
							(bstat_date, hits, word) VALUES ('$date', 1, '$word');";
				
					}else{
						$request = "UPDATE $bsuite_tables[bstat_words] ";
						
						foreach($rows as $row){
							$request .= "SET hits = " . ($row->hits + 1) . " ";
							}
						$request .= "WHERE bstat_id = " . $row->bstat_id;
						}
				
					$wpdb->query($request);
					}
				}
			}
		}
	$bstat_shortcircuit = TRUE;
	}
// end function bstat_hitit



//
// fetch the data, format it, return it
//
function bstat_reporter($request, $before, $after, $baseurl = 1, $wrap = 0) {
	global $wpdb; 

	if($baseurl == 0){
		$baseurl = "";
	}else if($baseurl == 1){
		$baseurl = get_settings('home') . "/";
		}

	$rows = $wpdb->get_results($request);
	
	if(count($rows)>0){
		$report = "";
		foreach($rows as $row){
			if(($row->post_id) && ($row->comment_id)){
				$url = (get_permalink($row->post_id) . "#comment-" . ($row->comment_id));
			}else if($row->post_id){
				$url = get_permalink($row->post_id);
			}else{
				$url = ($baseurl . urldecode($row->url));
				}
			
			$linktext = urldecode($row->title);
			if($wrap > 0)
				$linktext = wordwrap($linktext, $wrap, "<br />\n", 1);
			
			$report .= $before . "<a href=\"" . $url . "\" title=\"" . ($row->tooltip) . "\">" . $linktext . "</a>" . ($row->note) . $after;
			}
		return($report);
		}
	}
// end function bstat_reporter



//
// fetch the title for a post
//
function bstat_posttitle($id) {
	global $wpdb, $tableposts; 

	$request = "SELECT post_title
		FROM $tableposts
		WHERE ID = $id
		LIMIT 1
		";

	$rows = $wpdb->get_results($request);
	
	if(count($rows)>0){
		$report = ($rows[0]->post_title);
		}
	return($report);
	}
// end function bstat_posttitle



//
// Display today's popular stories
//
function bstat_todaypop($maxresults, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables, $tableposts;

	$date  = date("Y-m-d");

	$request = "SELECT a.post_id AS post_id, b.post_title AS title, a.hits_reads AS sort_order, CONCAT(' (', a.hits_reads, ')') AS note
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date = '$date'
		AND b.post_status <> 'draft'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
			
	if($return){
		return(bstat_reporter($request, $before, $after, 1));
	}else{
		echo(bstat_reporter($request, $before, $after, 1));
		}
	}
// end function bstat_todaypop



//
// Display recently popular stories
//
function bstat_recentpop($maxresults, $days, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables, $tableposts;

	$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $days, date("Y")));

	$request = "SELECT a.post_id AS post_id, b.post_title AS title, SUM(a.hits_reads) AS sort_order, CONCAT(' (', SUM(a.hits_reads), ')') AS note
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		AND b.post_status <> 'draft'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";
	
	if($return){
		return(bstat_reporter($request, $before, $after, 1));
	}else{
		echo(bstat_reporter($request, $before, $after, 1));
		}
	}
// end function bstat_recentpop



//
// Display today's popular links
//
function bstat_todaypoplinks($maxresults, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables;

	$date  = date("Y-m-d");

	$request = "SELECT CONCAT('http://', url) AS url, REPLACE(LEFT(url, (LOCATE('/', url) - 1)), 'www.', '') AS title, CONCAT(' (', SUM(hits), ')') AS note, SUM(hits) AS sort_order
		FROM $bsuite_tables[bstat_out] 
		WHERE bstat_date = '$date'
		GROUP BY url
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 0, 20));
	}else{
		echo(bstat_reporter($request, $before, $after, 0, 20));
		}
	}
// end function bstat_todaypoplinks



//
// Display recently popular links
//
function bstat_recentpoplinks($maxresults, $days, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables;

	$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $days, date("Y")));

	$request = "SELECT CONCAT('http://', url) AS url, REPLACE(LEFT(url, (LOCATE('/', url) - 1)), 'www.', '') AS title, CONCAT(' (', SUM(hits), ')') AS note, SUM(hits) AS sort_order
		FROM $bsuite_tables[bstat_out] 
		AND bstat_date > '$date'
		GROUP BY url
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 0, 20));
	}else{
		echo(bstat_reporter($request, $before, $after, 0, 20));
		}
	}
// end function bstat_recentpoplinks



//
// Display today's search terms
//
function bstat_todayrefs($maxresults, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables, $tableposts;

	$date  = date("Y-m-d");

	$request = "SELECT a.post_id AS post_id, LEFT(a.ref, 30) AS title, a.hits AS sort_order, CONCAT(' (', a.hits, ')') AS note
		FROM $bsuite_tables[bstat_refs] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND bstat_date = '$date'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 1, 20));
	}else{
		echo(bstat_reporter($request, $before, $after, 1, 20));
		}
	}
// end function bstat_todayrefs



//
// Display recent search terms
//
function bstat_recentrefs($maxresults, $days, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables, $tableposts;

	$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $days, date("Y")));

	$request = "SELECT a.post_id AS post_id, LEFT(a.ref, 30) AS title, SUM(a.hits) AS sort_order, CONCAT(' (', SUM(a.hits), ')') AS note
		FROM $bsuite_tables[bstat_refs] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 1, 20));
	}else{
		echo(bstat_reporter($request, $before, $after, 1, 20));
		}
	}
// end function bstat_recentrefs



//
// Display all search terms for a particular story
//
function bstat_refsforpost($post_id, $before, $after, $return = 0) {
	global $wpdb, $bsuite_tables, $tableposts;

	$request = "SELECT '$post_id' AS post_id, a.ref AS title, SUM(a.hits) AS sort_order, CONCAT(' (', SUM(a.hits), ')') AS note
		FROM $bsuite_tables[bstat_refs] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 1
		AND a.post_id = $post_id
		GROUP BY a.ref
		ORDER BY sort_order DESC
		LIMIT 150
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 1));
	}else{
		echo(bstat_reporter($request, $before, $after, 1));
		}
	}
// end function bstat_refsforpost




//
// Display recently commented stories
//
function bstat_discussionbypost($maxresults, $before, $after, $return = 0) {
	global $wpdb, $tablecomments, $tableposts; 

	$request = "SELECT a.comment_post_ID AS post_id, MAX(a.comment_ID) AS comment_id, b.post_title AS title, CONCAT(' (', COUNT(*), ')') AS note, MAX(a.comment_date) AS sort_order
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		GROUP BY comment_post_id
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 1));
	}else{
		echo(bstat_reporter($request, $before, $after, 1));
		}
	}
// end function bstat_discussionbypost



//
// Display recent comments
//
function bstat_discussionbycomment($maxresults, $before, $after, $return = 0) {
	global $wpdb, $tablecomments, $tableposts; 

	$request = "SELECT a.comment_post_ID AS post_id, a.comment_ID AS comment_id, b.post_title AS title, CONCAT(' (', a.comment_author, ')') AS note, a.comment_date AS sort_order
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		ORDER BY sort_order DESC
		LIMIT $maxresults
		";

	if($return){
		return(bstat_reporter($request, $before, $after, 1));
	}else{
		echo(bstat_reporter($request, $before, $after, 1));
		}
	}
// end function bstat_discussionbycomment



//
// Display pulse graph for story
//
function bstat_pulse($post_id = 0, $maxwidth = 400, $disptext = 1, $dispcredit = 1, $accurate = 4) {
	global $wpdb, $bsuite_tables;

	if($post_id == 0){
		$request = "SELECT SUM(hits_reads) AS hits_reads, bstat_date
			FROM $bsuite_tables[bstat_hits]
			GROUP BY bstat_date
			ORDER BY bstat_date ASC
			";
	}else{
		$request = "SELECT hits_reads, bstat_date
			FROM $bsuite_tables[bstat_hits]
			WHERE post_id = $post_id
			ORDER BY bstat_date ASC
			";
		}

	$rows = $wpdb->get_results($request);
	$tot = count($rows);
	
	if(count($rows)>0){
		$point = null;
		$point[] = 0;
		foreach($rows as $row){
			$point[] = $row->hits_reads;
			}
		$sum = array_sum($point);
		$max = max($point);
		$avg = round($sum / $tot);

		if($accurate == 4){
			$graphaccurate = get_option('bstat_graphaccurate');
		}else{
			$graphaccurate = $accurate;
			}
		
		$minwidth = ($maxwidth / 8.1);
		if($graphaccurate) $minwidth = ($maxwidth / 4.1);
		
		while(count($point) <= $minwidth){
			$newpoint = null;
			for ($i = 0; $i < count($point); $i++) {
				if($i > 0){
					if(!$graphaccurate) $newpoint[] = ((($point[$i-1] * 2) + $point[$i]) / 3);
					$newpoint[] = (($point[$i-1] + $point[$i]) / 2);
					if(!$graphaccurate) $newpoint[] = (($point[$i-1] + ($point[$i-1] * 2)) / 3);
					}
				$newpoint[] = $point[$i];
				}
			$point = $newpoint;
			}


		$tot = count($point);
		$width = round($maxwidth / $tot);
		if($width > 3)
			$width = 4;

		if(($width  * $tot) > $maxwidth)
			$skipstart = (($width  * $tot) - $maxwidth) / $width;

		$i = 1;
		$hit_chart = "";
		foreach($point as $row){
			if((!$skipstart) || ($i > $skipstart)){
				$hit_chart .= "<img src='" . get_settings('home') . "/wp-content/spacer.gif' width='$width' height='" . round((($row) / $max) * 100) . "' alt='graph element.' />";
				}
			$i++;
			}
			
		$pre = "<div id=\"bstat_pulse\">";
		$post = "</div>";
		$disptext = ($disptext == 1) ? ("$sum total reads, averaging $avg daily") : ("");
		$dispcredit = ($dispcredit == 1) ? ("<small><a href='http://maisonbisson.com/blog/search/bsuite' title='a pretty good WordPress plugin'>stats powered by bsuite</a></small>") : ("");
		$disptext = (($disptext) || ($dispcredit)) ? ("\n<p>$disptext\n<br />$dispcredit</p>") : ("");
		
		echo($pre . $hit_chart . "\n" . $disptext . $post);
		}
	}
// end function bstat_pulse



//
// read through an bunch of HTML and return
// the links as a sorted & uniqu'd array
//
function bsuite_geturls($content) {

	// most of this code stolen from pingback() in
	// wp-includes/comment-functions.php
	// the code there notes:
	// original code by Mort (http://mort.mine.nu:8080)
	$post_links = array();

	// Variables
	$ltrs = '\w';
	$gunk = '/#~:.?+=&%@!\-';
	$punc = '.:?\-';
	$any = $ltrs . $gunk . $punc;

	// Parse the post, put external links (if any) in $post_links array
	// This regexp comes straight from phpfreaks.com
	// http://www.phpfreaks.com/quickcode/Extract_All_URLs_on_a_Page/15.php
	preg_match_all("{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $content, $post_links);
	sort($post_links[0]);
	return(array_unique($post_links[0]));
	}
// end function bsuite_geturls



//
// read through an bunch of HTML and
// return an array of both the formatted content and the raw tags
//
function bsuite_gettags_from_content($content) {
	$loweredcontent = strtolower($content);

	// find any rel="tag" links
	$atags = array();
	$tag_pattern = '/(rel=[\'|"]tag[\'|"]\>(.*?)\<\/a\>)/i';
	preg_match_all($tag_pattern, $loweredcontent, $atags);

	// find any <tag>Tag Name</tag> tags
	$btags = array();
    $tag_pattern = '/(<tag>(.*?)<\/tag>)/i';
	preg_match_all($tag_pattern, $loweredcontent, $btags);
	// replace <tag>Tag Name</tag> with links to a tag resolver
	foreach($btags[2] as $btag){
		$content = str_replace("<tag>$btag</tag>", '<a href="http://technorati.com/tag/' . urlencode(strtolower(trim($btag))) . "\" rel=\"tag\">$btag</a>", $content);
		}

	// find any <tags>Tag 1,Tag 2,...</tag> tags
	$ctags = array();
    $tag_pattern = '/(<tags>(.*?)<\/tags>)/i';
	if (preg_match ($tag_pattern, $loweredcontent, $matches)) {
		$ctags = explode(',', $matches[2]);
		}
	// remove the <tags></tags> text block 
	// (a block of links to a tag resolver will be inserted later)
	if($matches[2])
		$content = preg_replace($tag_pattern, '', $content);

	// concatenate all the tags in one array
	$post_tags = array();
	$post_tags = array_unique(array_merge($atags[2], $btags[2], $ctags));
	sort($post_tags);
	
	// remove Ecto's tag block
	// Ecto is an XML-RPC client, more info at http://ecto.kung-foo.tv/
	$content = preg_replace('/<!-- technorati tags start -->(.*?)<!-- technorati tags end -->/i', '', $content);

	if($post_tags){
		// create and insert a block of tag links at the end of the post
		$taglinks = '<p class="bsuite_tagblock" style="text-align:right;font-size:10px;">tags: ';
		foreach($post_tags as $post_tag){
			$taglinks .= '<a href="http://technorati.com/tag/' . urlencode(strtolower(trim($post_tag))) . "\" rel=\"tag\">$post_tag</a>, ";
			}
		$taglinks = substr($taglinks, 0, -2);
		$taglinks .= '</p>';
		$content .= $taglinks;
		}
	
	$result['content'] = $content;
	$result['tags'] = $post_tags;
	return($result);
	}
// end function bsuite_gettags_from_content



//
// call bsuite_gettags_from_content and return only the post content for display
//
function bsuite_taggy_post($content) {
	if(!get_option('bstat_bsuggestive'))
		return($content);

	$everything = bsuite_gettags_from_content($content);
	return($everything['content']);
	}
// end function bsuite_taggy_post



//
// the simple part of the search engine highlighting routine from Suda
// http://suda.co.uk/projects/SEHL/
// used here under GPL
//
function sehl_do_highlight($full_body, $q, $colour){
	//this fixes a bug in the preg_replace a little further on when the $q contains slashes
	$q = str_replace("/", "", $q);


	/* seperate tags and data from the HTML file INCLUDING comments, avoiding HTML in the comments */
	$pat = '/((<[^!][\/]*?[^<>]*?>)([^<]*))|((<!--[ \r\n\t]*)(.*)[ \r\n\t]*-->([^<]*))/si';
	preg_match_all($pat,$full_body,$tag_matches);

	/* loop through and highlight $q value in data and recombine with tags */
	for ($i=0; $i< count($tag_matches[0]); $i++) {
		/* ignore all text within these tags */
		if (
			(preg_match('/<!/i', $tag_matches[0][$i])) or 
			(preg_match('/<textarea/i', $tag_matches[2][$i])) or 
			(preg_match('/<script/i', $tag_matches[2][$i]))
		){
			/* array[0] is everything the REGEX found */
			$full_body_hl .= $tag_matches[0][$i];
//			$full_body_hl .= $tag_matches[2][$i].$tag_matches[3][$i];
		} else {
			$full_body_hl .= $tag_matches[2][$i];

			/* the slash-i is for case-insensitive and the slash-b's are for word boundries */

			/* this one ALMOST works, except if the string is at the start or end of a string*/
			$holder = preg_replace('/(.*?)(\W)('.preg_quote($q).')(\W)(.*?)/iu',"\$1\$2<span class=\"hl$colour\">\$3</span>\$4\$5",' '.$tag_matches[3][$i].' ');
			$full_body_hl .= substr($holder,1,(strlen($holder)-2));

			/* ORIGINAL REGEX with word boundries */
			/*
			$full_body_hl .= preg_replace("/(.*?)\b(".preg_quote($q).")\b(.*?)/i", "\$1<span class=\"hl$colour\">\$2</span>\$3", $tag_matches[3][$i]);
			*/
		}
	}
	/* return tagged text */
	return $full_body_hl;
}
// end function sehl_do_highlight



//
// highlite search terms
//
function bsuite_hiliter($content) {
	if(!get_option('bstat_hiliter'))
		return($content);

	global $id;

	/* initialise variables */
	$colour      = 0; /* zero-out variables */
	$max_colours = 5; /* Number of highlight colours in the css */
	$notice	= "";
	
	if(!$hilite_words){
		static $hilite_words = "!";
		if($_REQUEST['hilite_words']){
			$hilite_words = urldecode($_REQUEST['hilite_words']);
		}else{
			$hilite_words = bstat_getref();
			if($hilite_words['issearchengine'] == 1){
				$hilite_words = $hilite_words['searchstring'];
			}else{
				$hilite_words = '!';
				}
			}
		}

	if(($hilite_words) && ($hilite_words <> '!')){

		$refs = explode(" ", $hilite_words);
		
		if(count($refs > 0)){
			if(count($refs > 1)){
				$notice = "<div id='bstat_hilite'>The following search terms have been highlighted: ";
			}else{
				$notice = "<div id='bstat_hilite'>The following search term has been highlighted: ";
				}
			
			foreach($refs as $ref){
				$thiscolour = bcmod($colour,$max_colours);
				$content = sehl_do_highlight($content, $ref, $thiscolour);
				$notice .= "<span class=\"hl$thiscolour\">$ref</span> ";
				$colour++;
				}

			$bsuggestive = bsuggestive_alternates($hilite_words);

			$notice .= "$bsuggestive</div>\n";
			}
		
//		return($content);
		return($notice.$content);
	}else{
		return($content);
		}
	}
// end function bstat_highliter



//
// get links to other posts for search
//
function bsuggestive_alternates($search) {
	global $id, $bsuite_tables, $tableposts;
	
	$search = addslashes($search);
		
	$request = "SELECT ID AS post_id, post_title AS title,
		CONCAT(' (score: ', MATCH (post_content, post_title) AGAINST ('$search') , ')') AS note
		FROM $tableposts 
		WHERE MATCH (post_content, post_title)
		AGAINST ('$search')
		AND post_status = 'publish'
		LIMIT 5
		";
		
	$altsearch = "<ul>" . (bstat_reporter($request, '<li>', '</li>', 1)) . "</ul>";

	if($altsearch)
		$related_tool = "<br /><br /><div id=\"bsuggestive_footer\"><h3>Other posts matching your search:</h3>$altsearch</div>";

	return($related_tool);

	}
// end function bsuggestive_alternates



//
// insert links to related posts
//
function bsuggestive_related($content) {
	if(!get_option('bstat_bsuggestive'))
		return($content);

	global $id, $bsuite_tables, $tableposts;
	
	$related_list_cache = bsuite_speedcache_fetch($id, 60, TRUE, 'bsuggestive');

	if($related_list_cache){
		$related_list = $related_list_cache;
	}else{
		//get the tags for this post
		$everything = bsuite_gettags_from_content($content);
		$tags = $everything['tags'];
	
		if($tags){
			// make a search string from the tag array
			foreach($tags as $tag){
				$tagcloud .= (ereg_replace("[^a-z|A-Z|0-9| ]" , "", $tag) . " ");
				}
			
			$request = "SELECT ID AS post_id, post_title AS title, 
				CONCAT(' (score: ', MATCH (post_content, post_title) AGAINST ('$tagcloud') , ')') AS note
				FROM $tableposts 
				WHERE MATCH (post_content, post_title)
				AGAINST ('$tagcloud')
				AND ID <> '$id'
				AND post_status = 'publish'
				LIMIT 5
				";
	
			$related_list = "<ul>" . (bstat_reporter($request, '<li>', '</li>', 1)) . "</ul>";
			$related_list_cache = $related_list;
		}else{
			$related_list_cache = NULL;
			}	
		bsuite_speedcache_put($id, $related_list_cache, FALSE, 'bsuggestive');
		}	

	if($related_list)
		$related_tool = "\n\n<br /><div id=\"bsuggestive_footer\"><h3>Related:</h3>$related_list</div>";

	return($content . $related_tool);

	}
// end function bsuggestive_related



//
// adding the menus 
//
function bsuite_add_menu() {

	$bstat_userlevel = get_settings('bstat_userlevel') > 1 ? get_settings('bstat_userlevel') : 2;
	add_submenu_page('index.php', 'bsuite Reports', 'bsuite Reports', $bstat_userlevel, __FILE__, 'bstat_reports');
	add_options_page('bsuite Settings', 'bsuite', 8, __FILE__, 'bsuite_optionspage');
	//add_management_page('bstat Stats', 'bstat', 2, __FILE__, 'bstat_managementpage');
	}
// end bstat_add_menu



//
// the adminstration menu 
//
function bsuite_optionspage() {
	global $wpdb, $tableposts, $bsuite_tables;


	//phpinfo();

	
	// configure the tables on first use...
	//
	// get list of tables and look for our tables in it
	$request = "SHOW TABLES;";
	$rows = $wpdb->get_results($request);
	$hits_table = false;
	$refs_table = false;
	foreach($rows as $table) {
		foreach($table as $value) if($value==$bsuite_tables[bstat_hits]) $hits_table = true;
		foreach($table as $value) if($value==$bsuite_tables[bstat_refs]) $refs_table = true;
		foreach($table as $value) if($value==$bsuite_tables[bsuite_speedcache]) $speedcache_table = true;
		}

	$request = "SHOW INDEX FROM $tableposts;";
	$rows = $wpdb->get_results($request);
	$bsuggestive_index = false;
	foreach($rows as $index) {
		foreach($index as $value) if($value==$bsuite_tables[bsuggestive_index]) $bsuggestive_index = true;
		}

	if(!$hits_table){
		$request = "
			CREATE TABLE `$bsuite_tables[bstat_hits]` (
				  `bstat_id` bigint(20) unsigned NOT NULL auto_increment,
				  `bstat_date` date NOT NULL default '0000-00-00',
				  `post_id` mediumint(9) unsigned NOT NULL default '0',
				  `hits_reads` mediumint(9) unsigned NOT NULL default '0',
				  `hits_ads1` mediumint(9) unsigned NOT NULL default '0',
				  `hits_ads2` mediumint(9) unsigned NOT NULL default '0',
				  PRIMARY KEY  (`bstat_id`),
				  KEY `date` (`bstat_date`),
				  KEY `post_id` (`post_id`)
				) TYPE=MyISAM
				";
	  	$wpdb->query($request);
		}

	if(!$refs_table){
		$request = "
			CREATE TABLE `$bsuite_tables[bstat_refs]` (
				`bstat_id` bigint(20) unsigned NOT NULL auto_increment,
				`bstat_date` date NOT NULL default '0000-00-00',
				`post_id` mediumint(9) unsigned NOT NULL default '0',
				`hits` mediumint(9) unsigned NOT NULL default '0',
				`issearchengine` tinyint(1) NOT NULL default '0',
				`ref` text NOT NULL,
				PRIMARY KEY  (`bstat_id`),
				KEY `date` (`bstat_date`),
				KEY `post_id` (`post_id`),
				KEY `ref` (`ref`(7))
				) TYPE=MyISAM
				";
	  	$wpdb->query($request);
	  	}

	if(!$speedcache_table){
		$request = "
			CREATE TABLE `$bsuite_tables[bsuite_speedcache]` (
			`cache_id` bigint(20) unsigned NOT NULL auto_increment,
			`cache_date` datetime NOT NULL default '0000-00-00 00:00:00',
			`cache_bank` enum('user','bsuggestive') NOT NULL default 'user',
			`cache_item` bigint(20) NOT NULL default '0',
			`cache_content` text NOT NULL,
			PRIMARY KEY  (`cache_id`),
			UNIQUE KEY `cache_uniq` (`cache_bank`,`cache_item`),
			KEY `cache_name` (`cache_item`)
			) TYPE=MyISAM
			";
	  	$wpdb->query($request);
	  	}

	if(!$bsuggestive_index){
		// DROP INDEX bsuggestive ON wp_posts
		$request = "
			CREATE FULLTEXT INDEX $bsuite_tables[bsuggestive_index] ON $tableposts (post_content,post_title)
			";
	  	$wpdb->query($request);
	  	}

/*
	if(!$out_table){
		$request = "
			CREATE TABLE `$bsuite_tables[bstat_out]` (
				`bstat_id` bigint(20) unsigned NOT NULL auto_increment,
				`bstat_date` date NOT NULL default '0000-00-00',
				`hits` mediumint(9) unsigned NOT NULL default '0',
				`post_id` mediumint(9) NOT NULL default '0',
				`url` text NOT NULL,
				PRIMARY KEY  (`bstat_id`),
				KEY `date` (`bstat_date`),
				KEY `url` (`url`(2))
				) TYPE=MyISAM			";
	  	$wpdb->query($request);
	  	}
*/
	if(!$hits_table || !$refs_table || !$speedcache_table || !$bsuggestive_index):

		update_option('bstat_userlevel', 5);
		update_option('bstat_defaultcss', 1);

?>
	<div class="updated">
		<h2><?=_e("Installation")?></h2>
		<p><?=_e("The <b>bsuite</b> plugin is now initialized. The bsuite tables have been created, but you must configure your template pages to count hits and display stats. If you choose to deactivate the plugin you must delete the bsuite tables manually.")?></p>
	</div>
<?
	endif;

	//  apply new settings if form submitted
	if(isset($_POST['Options'])){
		$bstat_userlevel = is_numeric($_POST['bstat_userlevel']) == true ? intval($_POST['bstat_userlevel']) : 0;
		update_option('bstat_userlevel', $bstat_userlevel);

		$bstat_defaultcss = $_POST['bstat_defaultcss'] == 1 ? 1 : 0;
		update_option('bstat_defaultcss', $bstat_defaultcss);

		$bstat_graphaccurate = $_POST['bstat_graphaccurate'] == 1 ? 1 : 0;
		update_option('bstat_graphaccurate', $bstat_graphaccurate);

		$bstat_bsuggestive = $_POST['bstat_bsuggestive'] == 1 ? 1 : 0;
		update_option('bstat_bsuggestive', $bstat_bsuggestive);

		$bstat_hiliter = $_POST['bstat_hiliter'] == 1 ? 1 : 0;
		update_option('bstat_hiliter', $bstat_hiliter);

		$bstat_refmoderation = $_POST['bstat_refmoderation'] == 1 ? 1 : 0;
		update_option('bstat_refmoderation', $bstat_refmoderation);

		$bstat_ignoreulevel = is_numeric($_POST['bstat_ignoreulevel']) == true ? intval($_POST['bstat_ignoreulevel']) : 0;
		update_option('bstat_ignoreulevel', $bstat_ignoreulevel);

		update_option('bstat_ignoreips', (ereg_replace("[^0-9*.\n]", "", $_POST['bstat_ignoreips'])));

		echo '<div class="updated"><p><strong>' . __('Options updated.', 'bstat') . '</strong></p></div>';
		}

	// get checkbox status settings
	$bstat_userlevel = get_settings('bstat_userlevel');
	$ck_bstat_userlevel = $bstat_userlevel <> NULL ? "<option value='$bstat_userlevel' selected='selected'>$bstat_userlevel</option>" : "<option value='5' selected='selected'>5</option>";

	$bstat_defaultcss = get_settings('bstat_defaultcss');
	$ck_bstat_defaultcss = $bstat_defaultcss == 1 ? ' checked="checked"' : '';

	$bstat_graphaccurate = get_settings('bstat_graphaccurate');
	$ck_bstat_graphaccurate = $bstat_graphaccurate == 1 ? ' checked="checked"' : '';
	$ck_bstat_graphaccurate_fuzzy = $bstat_graphaccurate == 0 ? ' checked="checked"' : '';

	$bstat_bsuggestive = get_settings('bstat_bsuggestive');
	$ck_bstat_bsuggestive = $bstat_bsuggestive == 1 ? ' checked="checked"' : '';

	$bstat_hiliter = get_settings('bstat_hiliter');
	$ck_bstat_hiliter = $bstat_hiliter == 1 ? ' checked="checked"' : '';

	$bstat_refmoderation = get_settings('bstat_refmoderation');
	$ck_bstat_refmoderation = $bstat_refmoderation == 1 ? ' checked="checked"' : '';

	$bstat_ignoreulevel = get_settings('bstat_ignoreulevel');
	$ck_bstat_ignoreulevel = $bstat_ignoreulevel <> NULL ? "<option value='$bstat_ignoreulevel' selected='selected'>$bstat_ignoreulevel</option>" : "<option value='5' selected='selected'>5</option>";


	//  output settings/configuration form
?>

<div class="wrap">
<h2><?php _e('Options') ?></h2>
<form method="post">

<fieldset name="bsuite_general" class="options">
<legend><?php _e('General Options', 'bstat') ?></legend>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Minimum userlevel to view bsuite reports', 'bstat') ?>:</th>
			<td><select name="bstat_userlevel" id="bstat_userlevel">
				<? echo $ck_bstat_userlevel ?>
				<option value="2">2</option>
				<option value="3">3</option>
				<option value="4">4</option>
				<option value="5">5</option>
				<option value="6">6</option>
				<option value="7">7</option>
				<option value="8">8</option>
				<option value="9">9</option>
				<option value="10">10</option>
				</select></td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Output default CSS', 'bstat') ?>:</th>
			<td><input type="checkbox" name="bstat_defaultcss" id="bstat_defaultcss" <?php echo $ck_bstat_defaultcss ?> value="1" /> Enable<br />c'mon, take a look at the <a href="http://homepage.mac.com/misterbisson/projects/bsuite.css">sample CSS</a> and integrate it with youre theme and turn this option off</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Default pulse graph style', 'bstat') ?>:</th>
			<td><input type="checkbox" name="bstat_graphaccurate" id="bstat_graphaccurate" <?php echo $ck_bstat_graphaccurate ?> value="1" /> Accurate &nbsp; or &nbsp; <input type="checkbox" name="bstat_graphaccurate" id="bstat_graphaccurate" <?php echo $ck_bstat_graphaccurate_fuzzy ?> value="0" /> Fuzzy</td>
		</tr>
	</table>
	<div class="submit"><input type="submit" name="Options" value="<?php _e('Update Options', 'bstat') ?> &raquo;" /></div>
</fieldset>


<fieldset name="bsuite_bsuggestive" class="options">
<legend><?php _e('bsuggestive Options', 'bstat') ?></legend>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Suggest related entries in post<br />(<a href="http://www.maisonbisson.com/blog/post/10922/">enables tag support</a>)', 'bstat') ?>:</th>
			<td><br /><input type="checkbox" name="bstat_bsuggestive" id="bstat_bsuggestive" <?php echo $ck_bstat_bsuggestive ?> value="1" /> Enable</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Highlight search words and offer search help', 'bstat') ?>:</th>
			<td><input type="checkbox" name="bstat_hiliter" id="bstat_hiliter" <?php echo $ck_bstat_hiliter ?> value="1" /> Enable</td>
		</tr>
	</table>
	<div class="submit"><input type="submit" name="Options" value="<?php _e('Update Options', 'bstat') ?> &raquo;" /></div>
</fieldset>


<fieldset name="bsuite_tracking" class="options">
<legend><?php _e('Tracking Options', 'bstat') ?></legend>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Filter incoming search terms using comment moderation and blacklist words', 'bstat') ?>:</th>
			<td><br /><input type="checkbox" name="bstat_refmoderation" id="bstat_refmoderation" <?php echo $ck_bstat_refmoderation ?> value="1" /> Enable</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Ignore hits from registered users<br />at or above userlevel', 'bstat') ?>:</th>
			<td><select name="bstat_ignoreulevel" id="bstat_ignoreulevel">
				<? echo $ck_bstat_ignoreulevel ?>
				<option value="0">Off</option>
				<option value="5">5</option>
				<option value="6">6</option>
				<option value="7">7</option>
				<option value="8">8</option>
				<option value="9">9</option>
				<option value="10">10</option>
				</select></td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Ignore hits from these IP numbers', 'bstat') ?>:</th>
			<td><textarea name="bstat_ignoreips" cols="25" rows="4" id="format" style="font-size: 12px;" class="code"><?php echo get_settings('bstat_ignoreips'); ?></textarea><br />One IP per line.<br />"10.20.30.*" excludes "10\.20\.30\.(.*)".<br />Current IP = <?php echo $_SERVER[REMOTE_ADDR]; ?></td>
		</tr>
	</table>
	<div class="submit"><input type="submit" name="Options" value="<?php _e('Update Options', 'bstat') ?> &raquo;" /></div>
</fieldset>

</form>
</div>


<div class="wrap">
	<h2><?=_e('Documentation')?></h2>

<p>bsuite is collecting stats now, in time you'll see them appear in the <a href="index.php?page=bsuite.php">bsuite Reports tab</a> of the <a href="index.php">WP Dashboard</a>. But some of the bsuite features -- like reports of popular posts in your sidebar -- require you to add functions to your theme files. Take a look at the documentation below for full details.</p>

<p>Take a look at the options above and consider customizing the look by adding the bsuite CSS to your theme's CSS (<a href="http://homepage.mac.com/misterbisson/projects/bsuite.css">sample CSS here</a>).</p>

<p>Further documentation for this release can be <a href="http://www.maisonbisson.com/blog/post/10900/">found online</a>.</p>

</div>
<?

}
// end bstat_optionspage



//
// the reports menu 
//
function bstat_reports() {
	global $wpdb, $bsuite_tables, $tablecomments, $tableposts;
?>

<div class="wrap">
<h2><?php _e('Quick Stats') ?></h2>

<?php

$before = "<li>";
$after = "</li>\n";
$date  = date("Y-m-d");

$best_num = 9;
$request = "SELECT concat(sum(hits_reads),' (',dayname(bstat_date),')') as note FROM `$bsuite_tables[bstat_hits]` GROUP BY bstat_date ORDER BY bstat_date DESC LIMIT $best_num";

echo("<table><tr valign='top'><td><h4>Last $best_num Days</h4><ul>" . bstat_reporter($request, $before, $after, 1) . "</ul></td>");

echo("<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>");

$request = "SELECT SUM(hits_reads) AS note FROM `$bsuite_tables[bstat_hits]`";
echo("<td><h4>Total Page Loads</h4><ul>" . bstat_reporter($request, $before, $after, 1) . "</ul></td>");

echo("<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>");

$top_num = 10;
$request = "SELECT concat(sum(hits_reads),' (',bstat_date,')') as note, sum(hits_reads) as reads FROM `$bsuite_tables[bstat_hits]` GROUP BY bstat_date ORDER BY reads DESC LIMIT $top_num";
echo("<td><h4>Best $top_num Days</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

echo ("</tr></table>");

?>

</div>

<?php

	//  apply new settings if form submitted
	if(isset($_POST['Options'])){
		$bstat_topstories = is_numeric($_POST['bstat_topstories']) == true ? intval($_POST['bstat_topstories']) : 0;
		update_option('bstat_topstories', $bstat_topstories);
		
		$bstat_discussion = is_numeric($_POST['bstat_discussion']) == true ? intval($_POST['bstat_discussion']) : 0;
		update_option('bstat_discussion', $bstat_discussion);
		
		$bstat_referrers = is_numeric($_POST['bstat_referrers']) == true ? intval($_POST['bstat_referrers']) : 0;
		update_option('bstat_referrers', $bstat_referrers);
		
		$bstat_ads = is_numeric($_POST['bstat_ads']) == true ? intval($_POST['bstat_ads']) : 0;
		update_option('bstat_ads', $bstat_ads);
		
		$bstat_period = is_numeric($_POST['bstat_period']) == true ? intval($_POST['bstat_period']) : 0;
		update_option('bstat_period', $bstat_period);
		}



	// get checkbox status settings
	$bstat_topstories = get_settings('bstat_topstories');
	$ck_bstat_topstories = $bstat_topstories <> NULL ? "<option value='$bstat_topstories' selected='selected'>$bstat_topstories</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_discussion = get_settings('bstat_discussion');
	$ck_bstat_discussion = $bstat_discussion <> NULL ? "<option value='$bstat_discussion' selected='selected'>$bstat_discussion</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_referrers = get_settings('bstat_referrers');
	$ck_bstat_referrers = $bstat_referrers <> NULL ? "<option value='$bstat_referrers' selected='selected'>$bstat_referrers</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_ads = get_settings('bstat_ads');
	$ck_bstat_ads = $bstat_ads <> NULL ? "<option value='$bstat_ads' selected='selected'>$bstat_ads</option>" : "<option value='5' selected='selected'>5</option>";
	
	$bstat_period = get_settings('bstat_period');
	$ck_bstat_period = $bstat_period <> NULL ? "<option value='$bstat_period' selected='selected'>past $bstat_period days</option>" : "<option value='8' selected='selected'>This week</option>
";

?>

<div class="wrap">
<h2><?php _e('Stats Control Panel') ?></h2>
<form method="post">
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
		<tr valign="bottom">
			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Stories', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Comments and Trackbacks', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Referrers', 'bstat') ?>: </th>

<!--			<th width="15%" scope="col" style="text-align: center;"><?php _e('Top Paying Stories', 'bstat') ?>: </th>-->

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Period', 'bstat') ?>: </th>

			<th width="15%" scope="col" style="text-align: center;"><?php _e('Go', 'bstat') ?>: </th>

			</tr>

		<tr valign="top">
			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_topstories" id="bstat_topstories">
				<? echo $ck_bstat_topstories ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_discussion" id="bstat_discussion">
				<? echo $ck_bstat_discussion ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_referrers" id="bstat_referrers">
				<? echo $ck_bstat_referrers ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>

<!--			<td style="text-align: center;"><?php _e('show', 'bstat') ?> <select name="bstat_ads" id="bstat_ads">
				<? echo $ck_bstat_ads ?>
				<option value="0">0</option>
				<option value="5">5</option>
				<option value="15">15</option>
				<option value="50">50</option>
				<option value="100">100</option>
				</select></td>-->

			<td style="text-align: center;"><select name="bstat_period" id="bstat_period">
				<? echo $ck_bstat_period ?>
				<option value="1">Today</option>
				<option value="8">This week</option>
				<option value="15">Two Weeks</option>
				<option value="31">Month</option>
				<option value="90">Quarter</option>
				<option value="366">Year</option>
				<option value="3651">10 Years</option>
				</select></td>

			<td style="text-align: center;"><input type="submit" name="Options" value="<?php _e('Show', 'bstat') ?> &raquo;" /></td>

			</tr>
	</table>
</form>
</div>

<?php

$before = "<li>";
$after = "</li>\n";
$date  = date("Y-m-d", mktime(0, 0, 0, date("m")  , date("d") - $bstat_period, date("Y")));

?>

<? if($bstat_topstories > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Stories') ?></h2>

<?php

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 60) AS title, ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)) AS sort_order, CONCAT('<br /><small>Tot:</small> ', SUM(a.hits_reads), '<small>, Avg:</small> ', ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)), '<small>, Max:</small> ', MAX(a.hits_reads), '') AS note
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_topstories
	";
echo("<table><tr valign='top'><td><h4>Most Reads Per Day</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 60) AS title, SUM(a.hits_reads) AS sort_order, CONCAT('<br /><small>Tot:</small> ', SUM(a.hits_reads), '<small>, Avg:</small> ', ROUND((SUM(a.hits_reads)) / ((TO_DAYS(NOW()) - TO_DAYS(MIN(a.bstat_date))) + 1)), '<small>, Max:</small> ', MAX(a.hits_reads), '') AS note
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_topstories
	";
echo("<td><h4>Most Total Reads</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");

?>

</div>
<? } ?>



<? if($bstat_discussion > 0){ ?>
<div class="wrap">
<h2><?php _e('Comments and Trackbacks') ?></h2>

<?php

$request = "SELECT a.comment_post_ID AS post_id, MAX(a.comment_ID) AS comment_id, CONCAT('<br />', MAX(a.comment_date)) AS note,  LEFT(b.post_title, 60) AS title
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		AND comment_date > '$date'
		GROUP BY comment_post_id
		ORDER BY note DESC
		LIMIT $bstat_discussion
	";
echo("<table><tr valign='top'><td><h4>Recently Commented Posts</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.comment_post_ID AS post_id, a.comment_ID AS comment_id, CONCAT('<br />', a.comment_date) AS note, CONCAT(a.comment_author, ' <small>on</small> ', LEFT(b.post_title, 20)) AS title
		FROM $tablecomments a , $tableposts b
		WHERE a.comment_post_ID = b.ID
		AND a.comment_approved = '1'
		AND comment_date > '$date'
		ORDER BY note DESC
		LIMIT $bstat_discussion
	";
echo("<td><h4>Recent Comments</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");

?>

</div>
<? } ?>



<? if($bstat_referrers > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Referrers') ?></h2>

<?php

$request = "SELECT a.post_id AS post_id, a.ref AS title, SUM(a.hits) AS sort_order, CONCAT('<br />', SUM(a.hits), ' hits, last hit on ', MAX(a.bstat_date)) AS note, 'Go To...' AS tooltip
		FROM $bsuite_tables[bstat_refs] a, $tableposts b 
		WHERE a.post_id = b.ID
		AND issearchengine = 1
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<table><tr valign='top'><td><h4>Top Incoming Searches</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.ref AS url, LEFT(a.ref, 60) AS title, SUM(a.hits) AS sort_order, CONCAT('<br />', SUM(a.hits), ' hits to ', LEFT(b.post_title, 70)) AS note, 'Go To...' AS tooltip
		FROM $bsuite_tables[bstat_refs] a, $tableposts b 
		WHERE a.post_id = b.ID	
		AND issearchengine = 0
		AND bstat_date > '$date'
		GROUP BY a.post_id, a.ref
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<td colspan='2'><h4>Top (Non-Search Engine) Referrers</h4><ol>" . bstat_reporter($request, $before, $after, 0) . "</ol></td></tr></table>");

?>

</div>
<? } ?>




<? /* if($bstat_referrers > 0){ ?>
<div class="wrap">
<h2><?php _e('Outgoing Links') ?></h2>

<?php

$request = "SELECT CONCAT('http://', url) AS url, LEFT(url, (LOCATE('/', url) - 1)) AS title, CONCAT(' (', SUM(hits), ')') AS note, SUM(hits) AS sort_order
		FROM $bsuite_tables[bstat_out] 
		WHERE bstat_date > '$date'
		GROUP BY url
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<table><tr valign='top'><td><h4>Top Outgoing Links</h4><ol>" . bstat_reporter($request, $before, $after, 0) . "</ol></td>");

$request = "SELECT a.post_id AS post_id, b.post_title AS title, SUM(a.hits) AS sort_order, CONCAT(' (', SUM(a.hits), ')') AS note, 'Go To...' AS tooltip
		FROM $bsuite_tables[bstat_out] a, $tableposts b
		WHERE  a.post_id = b.ID  
		AND bstat_date > '$date'
		GROUP BY post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_referrers
	";
echo("<td><h4>Top Exit Posts</h4><ol>" . bstat_reporter($request, $before, $after, 0) . "</ol></td></tr></table>");

?>

</div>
<? } */ ?>



<? if($bstat_ads > 0){ ?>
<div class="wrap">
<h2><?php _e('Top Paying Stories') ?></h2>

<?php
$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 50) AS title, CONCAT('<br /><small>Total:</small> ', SUM((a.hits_ads1 + a.hits_ads2)), '<small>, Rate:</small> ', (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads))) AS note, (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads)) AS sort_order
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_ads
	";
echo("<table><tr valign='top'><td><h4>Most Ad Hits Per Read</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td>");

$request = "SELECT a.post_id AS post_id, LEFT(b.post_title, 50) AS title, CONCAT('<br /><small>Total:</small> ', SUM((a.hits_ads1 + a.hits_ads2)), '<small>, Rate:</small> ', (SUM((a.hits_ads1 + a.hits_ads2)) / SUM(a.hits_reads))) AS note, (SUM(a.hits_ads1 + a.hits_ads2)) AS sort_order
		FROM $bsuite_tables[bstat_hits] a, $tableposts b 
		WHERE a.post_id = b.ID
		AND bstat_date > '$date'
		GROUP BY a.post_id
		ORDER BY sort_order DESC
		LIMIT $bstat_ads
	";
echo("<td><h4>Most Total Ad Hits</h4><ol>" . bstat_reporter($request, $before, $after, 1) . "</ol></td></tr></table>");
?>

</div>
<? } ?>



<div class="wrap">
<h2><?php _e('Pulse') ?></h2>

<style type="text/css">
<!--
#bstat_pulse	{ height: 130px; margin: 2px 0px 2px 0px; text-align:center; } 
#bstat_pulse p	{ text-align: center; line-height: 1em; text-shadow: #ffffff 1px 1px 4px; margin-top: 0px; } 
#bstat_pulse img	{ display:inline; vertical-align: middle; background-color: #999999; border: solid 0px #000000; margin: 0px 0px 0px 0px; padding: 0px 0px 0px 0px; border-top: solid 2px #000000; } 
-->
</style>
<div id=\"bstat_pulse\"><?php bstat_pulse(0, 800, 1, 0); ?></div>

</div>

<?
}
// end bstat_reports



//
// bsuite footer, automatically does the stats tracking
//
function bsuite_footer() {
	global $id;

	$bstat_ignoreulevel = get_option('bstat_ignoreulevel');
	if($bstat_ignoreulevel==0 || $GLOBALS['userdata']->user_level<$bstat_ignoreulevel){
		if (!is_single() && !is_page())
			$id = 0;
		bstat_hitit($id, "read");
		}
	}
// end bsuite_footer



//
// bsuite header, inserts default CSS
//
function bsuite_header() {
	if(!get_option('bstat_defaultcss'))
		return(TRUE);
?>

<style type="text/css">
<!--

/*

Styles necessary to support various bsuite features.
bsuite is a a WordPress plugin that does stats tracking
and a lot of other things I wanted done on my blog.
http://maisonbisson.com/blog/search/bsuite

Author: Casey Bisson
Author URI: http://maisonbisson.com/blog/

This CSS, such as it is, is released under the GPL:
http://www.opensource.org/licenses/gpl-license.php

*/

/* span styles for the search word highglighting feature */
.hl0	{ background-color: #FFFF99 }
.hl1	{ background-color: #FF99FF }
.hl2	{ background-color: #99FFFF }
.hl3	{ background-color: #FF9999 }
.hl4	{ background-color: #9999FF }

/* the style for the div that lists the hightlighted words */
#bstat_hilite	{ margin: 10px 0px 10px 0px; border: 1px dotted #999; padding: 10px; }


/* styles related to the pulse graph */
#bstat_pulse	{ height: 110px; margin: 2px 0px 2px 0px; text-align:center; } 
#bstat_pulse p	{ text-align: center; line-height: 1em; text-shadow: #ffffff 1px 1px 4px; margin-top: -30px; } 
#bstat_pulse img	{ display:inline; vertical-align: middle; background-color: #999999; border: solid 0px #000000; margin: 0px 0px 0px 0px; padding: 0px 0px 0px 0px; border-top: solid 2px #000000; } 

/* styles related to the bsuggestive list of related posts */
#bsuggestive_footer	{ 
	margin: 0px 0px 0px 0px; 
	border-top: 1px dotted #999; 
	padding: 10px; 
	background: transparent;
	color: #443;
	font-size: 11px;
	text-align: left;	
	}
	
#bsuggestive_footer h3	{
	color: #005577;
	font-size: 13px;
	margin: 0px 0px 0px 0px;
	padding: 0px;
	}

#bsuggestive_footer ul {
	list-style-type: none;
	margin: 0 0 0 10px;
	padding: 0;
	}
	
#bsuggestive_footer li {
	text-indent: -10px;
	line-height: 1.5em;
	list-style-type: none;
	margin: 0;
	padding: 0;
	}

#bsuggestive_footer li:before {
	content: "\00BB \0020";
	}

-->
</style>


<?
	}
// end bsuite_footer



//
// register WordPress hooks
//
add_action('admin_menu', 'bsuite_add_menu');
add_action('wp_footer', 'bsuite_footer');
add_action('wp_head', 'bsuite_header');
add_filter('the_content', 'bsuite_hiliter', 8);
add_filter('the_content', 'bsuggestive_related', 9);
add_filter('the_content', 'bsuite_taggy_post', 2);
//add_filter('the_content', 'bstat_setclicktrack', 9);
// end register WordPress hooks

?>
